<?php
require_once dirname(__FILE__) . '/Questions.php';
class Sabai_Addon_Questions_Controller_AllQuestions extends Sabai_Addon_Questions_Controller_Questions
{    
    private $_addon, $_tag = '';
    
    protected function _doExecute(Sabai_Context $context)
    {
        // Init add-on name
        if ($this->_addon = $context->getRequest()->asStr('addon', !empty($context->addon) ? $context->addon : 'Questions')) {
            try {
                $this->getAddon($this->_addon);
            } catch (Sabai_IException $e) {
                $this->LogError($e);
                $this->_addon = 'Questions';
            }
        } else {
            $this->_addon = 'Questions';
        }
        parent::_doExecute($context);
    }
    
    protected function _getDefaultSettings(Sabai_Context $context)
    {
        $category_id = 0;
        $tag_id = null;
        $category_bundle = $this->getAddon($this->_addon)->getCategoriesBundleName();
        $tag_bundle = $this->getAddon($this->_addon)->getTagsBundleName();
        if (isset($context->category)
            && ($category = $this->getModel('Term', 'Taxonomy')->entityBundleName_is($category_bundle)->name_is($context->category)->fetchOne())
        ) {
            $category_id = $category->id;
        }
        if (($tag_name = $context->getRequest()->asStr('tag', isset($context->tag) ? $context->tag : ''))
            && ($tag = $this->getModel('Term', 'Taxonomy')->entityBundleName_is($tag_bundle)->name_is($tag_name)->fetchOne())
        ) {
            $tag_id = $tag->id;
            $this->_tag = $tag_name;
        }
        $settings = array(
            'perpage' => $context->getRequest()->asInt('perpage', isset($context->perpage) ? (int)$context->perpage : 10),
            'sort' => isset($context->sort) ? $context->sort : null,
            'keywords' => array(),
            'parent_category' => $category_id,
            'category_bundle' => $category_bundle,
            'hide_searchbox' => $context->getRequest()->asBool('hide_searchbox', !empty($context->hide_searchbox)),
            'hide_nav' => $context->getRequest()->asBool('hide_nav', !empty($context->hide_nav)),
            'hide_pager' => $context->getRequest()->asBool('hide_pager', !empty($context->hide_pager)),
            'feature' => $context->getRequest()->asBool('feature', !isset($context->feature) || !empty($context->feature)), // make featured questions sticky?
            'featured_only' => $context->getRequest()->asBool('featured_only', !empty($context->featured_only)),
            'filter' => isset($context->filter) ? $context->filter : '',
            'tag' => $tag_id,
        );
        return $settings; 
    }
    
    protected function _getUrlParams(Sabai_Context $context, Sabai_Addon_Entity_Model_Bundle $bundle = null)
    {
        return parent::_getUrlParams($context, $bundle) + array(
            'perpage' => $this->_settings['perpage'],
            'feature' => $this->_settings['feature'],
            'featured_only' => $this->_settings['featured_only'],
            'hide_searchbox' => $this->_settings['hide_searchbox'],
            'hide_nav' => $this->_settings['hide_nav'],
            'hide_pager' => $this->_settings['hide_pager'],
            'addon' => $this->_addon === 'Questions' ? '' : $this->_addon,
            'tag' => $this->_tag,
        );
    }
    
    protected function _getBundle(Sabai_Context $context)
    {
        return $this->Entity_Bundle($this->getAddon($this->_addon)->getQuestionsBundleName());
    }
}