<?php
class Sabai_Addon_Questions_Controller_Answers extends Sabai_Addon_Content_Controller_ListChildPosts
{    
    protected function _getSorts(Sabai_Context $context)
    {
        return array(
            'votes' => array(
                'label' => __('Votes', 'sabai-discuss'),
                'title' => __('Sort by most voted', 'sabai-discuss'),
            ),
            'active' => array(
                'label' => __('Active', 'sabai-discuss'),
                'title' => __('Sort by most recent activity', 'sabai-discuss'),
                ),
            'oldest' => array(
                'label' => __('Oldest', 'sabai-discuss'),
                'title' => __('Sort by oldest', 'sabai-discuss'),
            ),
        );
    }
    
    protected function _createQuery(Sabai_Context $context, $sort, Sabai_Addon_Entity_Model_Bundle $bundle = null)
    {
        $query = parent::_createQuery($context, $sort, $bundle);
        switch ($sort) {
            case 'active':
                return $query->sortByField('content_activity', 'DESC', 'active_at');
            case 'oldest':
                return $query->sortByProperty('post_published', 'ASC');
            default:
                return $query->sortByField('voting_updown', 'DESC', 'sum');
        }
    }
}