<?php
class Sabai_Addon_Questions_Controller_UserQuestions extends Sabai_Addon_Content_Controller_ListPosts
{    
    protected function _getSorts(Sabai_Context $context)
    {
        return array(
            'newest' => array(
                'label' => __('Newest', 'sabai-discuss'),
                'title' => __('Sort by most recent', 'sabai-discuss'),
            ),
            'active' => array(
                'label' => __('Active', 'sabai-discuss'),
                'title' => __('Sort by most recent activity', 'sabai-discuss'),
                ),
            'votes' => array(
                'label' => __('Votes', 'sabai-discuss'),
                'title' => __('Sort by most voted', 'sabai-discuss'),
            ),
            'views' => array(
                'label' => __('Views', 'sabai-discuss'),
                'title' => __('Sort by most viewed', 'sabai-discuss'),
            ),
        );
    }
    
    protected function _createQuery(Sabai_Context $context, $sort, Sabai_Addon_Entity_Model_Bundle $bundle = null)
    {
        $query = parent::_createQuery($context, $sort, $bundle)
            ->propertyIs('post_user_id', $context->identity->id);
        switch ($sort) {
            case 'active':
                return $query->sortByField('content_activity', 'DESC', 'active_at');
            case 'votes':
                return $query->sortByField('voting_updown', 'DESC', 'sum');
            case 'views':
                return $query->sortByProperty('post_views', 'DESC');
            default:
                return $query->sortByProperty('post_published', 'DESC');
        }
    }
}