<?php
class Sabai_Addon_Questions_Helper_Query extends Sabai_Helper
{
    public function help(Sabai $application, Sabai_Addon_Entity_Query $query, $category, $tag, $sort, $filter = '', $feature = false, $featuredOnly = false)
    {
        if (isset($category)) {
            if (!empty($category)) {
                $category_ids = array($category);
                foreach ($application->Taxonomy_Descendants($category) as $_category) {
                    $category_ids[] = $_category->id;
                }
                $query->fieldIsIn('questions_categories', $category_ids);
            }
        }
        if (!empty($tag)) {
            $query->fieldIs('questions_tags', $tag);
        }
        if ($filter !== '') {
            switch ($filter) {
                case 'resolved':
                    $query->fieldIs('questions_resolved', 1);
                    break;
                case 'unresolved':
                    $query->fieldIsNull('questions_resolved');
                    break;
                case 'closed':
                    $query->fieldIs('questions_closed', 1);
                    break;
                case 'open':
                    $query->fieldIsNull('questions_closed');
                    break;
            }
        }
        if (!empty($feature)) {
            $query->sortByField('content_featured', 'DESC');
        }
        if ($featuredOnly) {
            $query->fieldIs('content_featured', 1);
        }
        switch ($sort) {
            case 'active':
                return $query->sortByField('content_activity', 'DESC', 'active_at');
            case 'votes':
                return $query->sortByField('voting_updown', 'DESC', 'sum');
            case 'views':
                return $query->sortByProperty('post_views', 'DESC');
            case 'oldest':
                return $query->sortByProperty('post_published', 'ASC');
            default:
                return $query->sortByProperty('post_published', 'DESC');
        }
    }
}