<?php
/* This file has been auto-generated. Do not edit this file directly. */

abstract class Sabai_Addon_System_Model_Base_PermissionGateway extends SabaiFramework_Model_Gateway
{
    public function getName()
    {
        return 'system_permission';
    }

    public function getFields()
    {
        return array('permission_name' => SabaiFramework_Model::KEY_TYPE_VARCHAR, 'permission_title' => SabaiFramework_Model::KEY_TYPE_VARCHAR, 'permission_addon' => SabaiFramework_Model::KEY_TYPE_VARCHAR, 'permission_weight' => SabaiFramework_Model::KEY_TYPE_INT, 'permission_description' => SabaiFramework_Model::KEY_TYPE_TEXT, 'permission_guest_allowed' => SabaiFramework_Model::KEY_TYPE_BOOL, 'permission_id' => SabaiFramework_Model::KEY_TYPE_INT, 'permission_created' => SabaiFramework_Model::KEY_TYPE_INT, 'permission_updated' => SabaiFramework_Model::KEY_TYPE_INT, 'permission_permissioncategory_name' => SabaiFramework_Model::KEY_TYPE_VARCHAR);
    }

    protected function _getIdFieldName()
    {
        return 'permission_id';
    }

    protected function _getSelectByIdQuery($id, $fields)
    {
        return sprintf(
            'SELECT %s FROM %ssystem_permission WHERE permission_id = %d',
            empty($fields) ? '*' : implode(', ', $fields),
            $this->_db->getResourcePrefix(),
            $id
        );
    }

    protected function _getSelectByIdsQuery($ids, $fields)
    {
        return sprintf(
            'SELECT %s FROM %ssystem_permission WHERE permission_id IN (%s)',
            empty($fields) ? '*' : implode(', ', $fields),
            $this->_db->getResourcePrefix(),
            implode(', ', array_map('intval', $ids))
        );
    }

    protected function _getSelectByCriteriaQuery($criteriaStr, $fields)
    {
        return sprintf(
            'SELECT %1$s FROM %2$ssystem_permission system_permission WHERE %3$s',
            empty($fields) ? '*' : implode(', ', $fields),
            $this->_db->getResourcePrefix(),
            $criteriaStr
        );
    }

    protected function _getInsertQuery(&$values)
    {
        $values['permission_created'] = time();
        $values['permission_updated'] = 0;
        return sprintf('INSERT INTO %ssystem_permission(permission_name, permission_title, permission_addon, permission_weight, permission_description, permission_guest_allowed, permission_created, permission_updated, permission_permissioncategory_name) VALUES(%s, %s, %s, %d, %s, %u, %d, %d, %s)', $this->_db->getResourcePrefix(), $this->_db->escapeString($values['permission_name']), $this->_db->escapeString($values['permission_title']), $this->_db->escapeString($values['permission_addon']), $values['permission_weight'], $this->_db->escapeString($values['permission_description']), $this->_db->escapeBool($values['permission_guest_allowed']), $values['permission_created'], $values['permission_updated'], $this->_db->escapeString($values['permission_permissioncategory_name']));
    }

    protected function _getUpdateQuery($id, $values)
    {
        $last_update = $values['permission_updated'];
        $values['permission_updated'] = time();
        return sprintf('UPDATE %ssystem_permission SET permission_name = %s, permission_title = %s, permission_addon = %s, permission_weight = %d, permission_description = %s, permission_guest_allowed = %u, permission_updated = %d, permission_permissioncategory_name = %s WHERE permission_id = %d AND permission_updated = %d', $this->_db->getResourcePrefix(), $this->_db->escapeString($values['permission_name']), $this->_db->escapeString($values['permission_title']), $this->_db->escapeString($values['permission_addon']), $values['permission_weight'], $this->_db->escapeString($values['permission_description']), $this->_db->escapeBool($values['permission_guest_allowed']), $values['permission_updated'], $this->_db->escapeString($values['permission_permissioncategory_name']), $id, $last_update);
    }

    protected function _getDeleteQuery($id)
    {
        return sprintf('DELETE FROM %1$ssystem_permission WHERE permission_id = %2$d', $this->_db->getResourcePrefix(), $id);
    }

    protected function _getUpdateByCriteriaQuery($criteriaStr, $sets)
    {
        $sets['permission_updated'] = 'permission_updated=' . time();
        return sprintf('UPDATE %ssystem_permission system_permission SET %s WHERE %s', $this->_db->getResourcePrefix(), implode(', ', $sets), $criteriaStr);
    }

    protected function _getDeleteByCriteriaQuery($criteriaStr)
    {
        return sprintf('DELETE system_permission FROM %1$ssystem_permission system_permission WHERE %2$s', $this->_db->getResourcePrefix(), $criteriaStr);
    }

    protected function _getCountByCriteriaQuery($criteriaStr)
    {
        return sprintf('SELECT COUNT(*) FROM %1$ssystem_permission system_permission WHERE %2$s', $this->_db->getResourcePrefix(), $criteriaStr);
    }

    protected function _afterInsert1($id, array $new)
    {
    }

    protected function _afterDelete1($id, array $old)
    {
    }

    protected function _afterUpdate1($id, array $new, array $old)
    {
    }

    protected function _afterInsert($id, array $new)
    {
        $this->_afterInsert1($id, $new);
    }

    protected function _afterUpdate($id, array $new, array $old)
    {
        $this->_afterUpdate1($id, $new, $old);
    }

    protected function _afterDelete($id, array $old)
    {
        $this->_afterDelete1($id, $old);
    }
}